# python dns_roaming_home.py $code
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import sys

df = pd.read_csv("dns_detect_w_Telekom.csv",sep=';')

targets=['141.40.254.120', '163.117.253.6', '139.133.232.22', '130.192.181.137', '193.10.227.25', '128.39.37.161']

def create_title(target):
    title=None
    if(target=="163.117.253.6"):
        title = str(target) + " Spain"
    if(target=="141.40.254.120"):
        title = str(target) + " Germany"
    if(target=="139.133.232.22"):
        title = str(target) + " UK"
    if(target=="130.192.181.137"):
        title = str(target) + " Italy"
    if(target=="193.10.227.25"):
        title = str(target) + " Sweden"
    if(target=="128.39.37.161"):
        title = str(target) + " Norway"
    return title

def country_sim(target):
    title=None
    if(target=="163.117.253.6"):
        country_sim = "Spain"
    if(target=="141.40.254.120"):
        country_sim = "Germany"
    if(target=="139.133.232.22"):
        country_sim = "UK"
    if(target=="130.192.181.137"):
        country_sim = "Italy"
    if(target=="193.10.227.25"):
        country_sim = "Sweden"
    if(target=="128.39.37.161"):
        country_sim = "Norway"
    return country_sim

code=int(sys.argv[1])


################################
#max, min, avg
if code==26207:
    IMSIMCCMNCs = ['21407', '22201', '22288', '24201', '24007', '23410', '26203', '26207']
if code==23415:
    IMSIMCCMNCs = ['0']
if code==22210:
    IMSIMCCMNCs = ['0']
if code==22201:
    IMSIMCCMNCs = ['22201', '26201', '24202', '24001', '26201', '23430']
if code==22299:
    IMSIMCCMNCs = ['26201', '24202', '21404', '24002']
if code==23430:
    IMSIMCCMNCs = ['23430', '21404', '22201', '24001']
if code==24002:
    IMSIMCCMNCs = ['24002', '26207', '26203', '21407', '22288']
if code==26201:
    IMSIMCCMNCs = ['26201', '21403', '24202', '22201', '24001']
if code==24008:
    IMSIMCCMNCs = ['24008', '24201', '21401', '22210']
if code==21407:
    IMSIMCCMNCs = ['21407', '24201', '22201', '24001', '26203', '26207']
if code==21401:
    IMSIMCCMNCs = ['21401', '26202', '22210', '24008', '23415']
if code==24008:
    IMSIMCCMNCs = ['24008', '26201', '24201', '21401', '22210', '23430']
if code==26201:
    IMSIMCCMNCs = ['26201', '21403', '24202', '22201', '24001']

fqdns=['intext.linknavi1.com.', 'a1768.g1.akamai.net.', 'addon.downloadterms.com.', 'pricora.com.', 'dealply.com.', 'fp114.digitaloptout.com.', 'playtopus.com.', 'tr553.com.', 'ssfiles.com.', 'crbfjs.info.', 'webshieldonline.com.', 'ciuvo.com.', 'lp.optionsxo.com.', 'pricegong.com.', 'xrosview.com.', 'stegjs.info.', 'couponsvc.com.', 'browserutility1.net.', 'media-wajam.netdna-ssl.com.', 'j6i7c9j2.ssl.hwcdn.net.', 'nsdsvc.com.', 'ams.dfna.net.', 'aceadsys.net.', 'a1168.g.akamai.net.', 'spns.rotatemyad.com.', 'kaytri.com.', 'adserver-182505547.eu-west-1.elb.amazonaws.com.', 'spns.seriousads.net.', 'superfish.com.', 'baixaki.com.br.', 'donation-tools.org.', 'mntrlfjs.info.', 'staticwajam-wajam.netdna-ssl.com.', 'bestpriceninja.com.', 's3-1-w.amazonaws.com.', 'kingtopdeals.com.', 'nadijs.info.', 'gocash01.net.', 'betterdeals.co.', 'deals-way.com.', 'ver-pelis.net.', 'HDRedirect-LB3-890977680.us-east-1.elb.amazonaws.com.', 'adsupplyads.com.', 'datafastguru.info.', 'd25s4dbsms5nvt.cloudfront.net.', 'iabfjs.info.', 'flwapp.com.', 'adserver.iminent.com.cdngc.net.', 'find-allyouneed.com.', 'secure-content-delivery.com.', 'linknavi1.com.', 'fast-search.info.', 'shoppingate.info.', 'offeringmedia.com.', 'easyinline.com.', 'a948.g.akamai.net.', 'spns.adsrotator.net.', 'smartsuggestor.net.', 'intext.nav-links.com.', 'd2a8a4q9.ssl.hwcdn.net.', 'partners.cltrda.com.', 'best-deals-products.com.', 'tt.friendschecker.com.', 'spns.night-hawk.net.', 'imbaty.com.', 'textsrv.com.', 'theprivilegesbox.com.', 'revizereu.mediapricingengine.com.', 'gosignserv.com.', 'tt.toparcadehits.com.', 'park.jinmi.com.', 'crbsjs.info.', 'pricejs.info.', 'pricejs.net.', 'toprelatedtopics.com.', 'blkz2x.com.', 'a1983.g1.akamai.net.', 'ws.pricedetect.com.', 'widgets.wizebar.com.', 'wajam.com.', 'srv.mzcdn.com.', 'nav-links.com.', 'priceblink.com.', 'omnitwig.com.', 'fo-fd-world-new.yax.gysm.yahoodns.net.', 'jmp9.com.', 'linkbolic.com.', 'etoro.com.', 'ezpowerads.com.', 'winnering.info.', 'engageya.com.', 'sedoparking.com.', 'jollywallet.com.']
data_operator = df.loc[df['IMSIMCCMNC'] == code]

for fqdn in fqdns:
    data_fqdn = data_operator.loc[data_operator['fqdn'] == fqdn]
    data_fqdn_no_google = data_fqdn.loc[data_fqdn['server'] != "8.8.4.4"]
    data_fqdn_no_google2 = data_fqdn_no_google[data_fqdn_no_google['server'] != "8.8.8.8"]

    servers = data_fqdn_no_google2['server']
    #print servers.tolist()
    fqdn_dict_server=data_fqdn_no_google2.set_index('NodeId')['server'].to_dict()
    fqdn_dict_coor=data_fqdn_no_google2.set_index('NodeId')['GPS_loc'].to_dict()
    #print str(fqdn) + str(fqdn_dict_server) + str(fqdn_dict_coor)
    myset = set(servers.tolist())
    print str(fqdn)+str(myset)
    data_fqdn_no_google2_home = data_fqdn_no_google2[data_fqdn_no_google2['NWMCCMNC'] == code]
    fqdn_dict_server=data_fqdn_no_google2_home.set_index('NodeId')['server'].to_dict()
    fqdn_dict_coor=data_fqdn_no_google2_home.set_index('NodeId')['GPS_loc'].to_dict()
    #print str(fqdn) + str(fqdn_dict_server) + str(fqdn_dict_coor)
    servers = data_fqdn_no_google2_home['server']
    myset = set(servers.tolist())
    print "home: " + str(fqdn)+str(myset)

#check the node_id for that operator:
node_ids = data_fqdn_no_google2['NodeId']
node_id_list = set(node_ids.tolist())
print node_id_list

#loop the node_id to get the min query time for each fqdn:
file = open("results","w")
file.write ("fqdn"+";"+"node_id"+";"+"max_query"+ ";" + "min_query"+ ";" + "avg_query\n")
for fqdn in fqdns:
    list_query_time = []
    data_operator = df.loc[df['IMSIMCCMNC'] == code]
    data_fqdn = data_operator.loc[data_operator['fqdn'] == fqdn]
    data_fqdn_no_google = data_fqdn.loc[data_fqdn['server'] != "8.8.4.4"]
    data_fqdn_no_google2 = data_fqdn_no_google[data_fqdn_no_google['server'] != "8.8.8.8"]
    for node_id in node_id_list:
        data_node = data_fqdn_no_google2.loc[data_fqdn['NodeId'] == node_id]
        data_query=data_node['queryTime']
        list_query_time=data_query.tolist()
        if (len(list_query_time)!=0):
            max_query = max(list_query_time)
            min_query = min(list_query_time)
            avg_query = sum(list_query_time)/len(list_query_time)
            file.write(str(fqdn) + ";"+ str(node_id)+";" + str(max_query)+";"+ str(min_query)+";"+ str(avg_query)+"\n")
file.close()

df = pd.read_csv("results",sep=';')


#file = open("results","w")
#file.write ("country"+";"+"IMSIMCCMNC"+";"+"target" + ";" + "max_rtt"+ ";" + "avg_rtt"+ ";" + "min_rtt\n")
#for IMSIMCCMNC in IMSIMCCMNCs:
#        list_query_time = []
#        data_IMSIMCCMNCs = f.loc[f['IMSIMCCMNC'] == int(IMSIMCCMNC)]
#            data_country = data_IMSIMCCMNCs.loc[data_IMSIMCCMNCs['country'] == country]
#            data_rtt=data_country['rtt_target']
#            list_rtt=data_rtt.tolist()
#            if (len(list_rtt)!=0):
#                max_rtt = max(list_rtt)
#                min_rtt = min(list_rtt)
#                avg_rtt = sum(list_rtt)/len(list_rtt)
#                file.write(str(country)+";"+str(IMSIMCCMNC)+";"+ target + ";" + str(max_rtt)+";"+ str(avg_rtt)+";"+ str(min_rtt)+"\n")
#file.close()
#
