# how to use the script: python traceroute_distance_roaming_home operator we are analyzing
import json
import datetime
import ipaddress
import os
import sys

def distance_home(target, file, operator, node_id):
    distance_home2=1
    with open(file) as f:
        traceroute = json.load(f)
        roam_home2=roaming_home(operator, int(node_id))
    if (roam_home2== True):
        roam_home=roaming_home(operator, int(node_id))
        distance_home2=distance(target, file)
        return distance_home2
    else:
        return 1

def roaming_home (operator, node_id):
    roaming_home = None
    if((node_id==285 or node_id==329) and (operator=="Movistar" or operator=="Vodafone ES" or operator=="Orange")):
        roaming_home = True
    if((node_id==322 or node_id==323 or node_id==333 or node_id==332) and (operator=="Vodafone IT" or operator=="3IT" or operator=="I TIM")):
        roaming_home = True
    if((node_id==328 or node_id==298) and (operator=="Telenor NO" or operator=="Telia NO")):
        roaming_home = True
    if((node_id==496 or node_id==497) and (operator=="Telenor SE" or operator=="Telia SE" or operator=="3SE")):
        roaming_home = True
    if((node_id==519 or node_id==302) and ("o2 - de" in operator or operator=="Telekom" or operator=="Vodafone DE")):
        roaming_home = True
    if((node_id==549 or node_id==518)and (operator=="Vodafone UK" or operator=="EE")):
        roaming_home = True
    return roaming_home


###########################

def distance (target, file):
    num_private=0
    num_public=0
    num_none=0
    distance=0
    distance_no_none=0
    private_list=[]
    public_list=[]
    none_list=[]
    with open(file) as f:
        traceroute = json.load(f)
        operator = traceroute['Operator']
        node_id = traceroute['NodeId']
        roam_country=roaming_country_fun(node_id)
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
        	ip = hop['probes'][0]['ip']
        	if ip is not None:
            		private = ipaddress.ip_address(unicode(ip)).is_private
            		if private:
                		num_private=num_private+1
                		private_list.append(hop['hop'])
                		distance = distance+1
            		else:
                		num_public=num_public+1
                		public_list.append(hop['hop'])
                		distance = distance+1
        	else:
            		num_none=num_none+1
            		none_list.append(hop['hop'])
            		distance = distance+1
    distance_no_none = distance - num_none
    return distance

def private_ip_fun (target, file):
    num_private=0
    num_public=0
    num_none=0
    distance=0
    distance_no_none=0
    private_list=[]
    public_list=[]
    none_list=[]
    with open(file) as f:
        traceroute = json.load(f)
        operator = traceroute['Operator']
        node_id = traceroute['NodeId']
        roam_country=roaming_country_fun(node_id)
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip = hop['probes'][0]['ip']
            if ip is not None:
                private = ipaddress.ip_address(unicode(ip)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(hop['hop'])
                    distance = distance+1
                else:
                    num_public=num_public+1
                    public_list.append(hop['hop'])
                    distance = distance+1
                    break
            else:
                num_none=num_none+1
                none_list.append(hop['hop'])
                distance = distance+1
            distance_no_none = distance - num_none
    return num_private

def num_public_ip_first_AS_fun (target, file):
    num_private=0
    num_public=0
    num_none=0
    distance=0
    distance_no_none=0
    private_list=[]
    public_list=[]
    none_list=[]
    asn_public_list=[]
    num_public_first_as=0
    num_public_first_as2=0
    with open(file) as f:
        traceroute = json.load(f)
        operator = traceroute['Operator']
        node_id = traceroute['NodeId']
        roam_country=roaming_country_fun(node_id)
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip = hop['probes'][0]['ip']
            asn = hop['probes'][0]['asn']
            if ip is not None:
                private = ipaddress.ip_address(unicode(ip)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(hop['hop'])
                    distance = distance+1
                else:
                    if asn != "null":
                        num_public_first_as=num_public_first_as+1
                        public_list.append(hop['hop'])
                        distance = distance+1
                        asn_public_list.append(hop['probes'][0]['asn'])
                        for i in range (0, len(asn_public_list)):
                            if(str(asn_public_list[i]) != str(hop['probes'][0]['asn'])):
                                break;
            else:
                num_none=num_none+1
                none_list.append(hop['hop'])
                distance = distance+1
            distance_no_none = distance - num_none
    for i in range (0, len(asn_public_list)):
        if (asn_public_list[i]==asn_public_list[0]):
            num_public_first_as2= num_public_first_as2+1
    return num_public_first_as2

def all_public_ip_first_AS_fun (target, file):
    num_private=0
    num_public=0
    num_none=0
    distance=0
    distance_no_none=0
    private_list=[]
    public_list2=[]
    public_list=[]
    none_list=[]
    asn_public_list=[]
    num_public_first_as=0
    num_public_first_as2=0
    with open(file) as f:
        traceroute = json.load(f)
        operator = traceroute['Operator']
        node_id = traceroute['NodeId']
        roam_country=roaming_country_fun(node_id)
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip = hop['probes'][0]['ip']
            asn = hop['probes'][0]['asn']
            if ip is not None:
                private = ipaddress.ip_address(unicode(ip)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(hop['hop'])
                    distance = distance+1
                else:
                    if asn != "null":
                        num_public_first_as=num_public_first_as+1
                        public_list.append(hop['probes'][0]['ip'])
                        distance = distance+1
                        asn_public_list.append(hop['probes'][0]['asn'])
                        for i in range (0, len(asn_public_list)):
                            if(str(asn_public_list[i]) != str(hop['probes'][0]['asn'])):
                                break;
            else:
                num_none=num_none+1
                none_list.append(hop['hop'])
                distance = distance+1
            distance_no_none = distance - num_none
    for i in range (0, len(asn_public_list)):
        if (asn_public_list[i]==asn_public_list[0]):
            num_public_first_as2 = num_public_first_as2+1
            public_list2.append(public_list[i])
    return public_list2

def first_public_ip_fun(target, file):
    num_private=0
    num_none=0
    private_list=[]
    none_list=[]
    first_public_ip2 = None
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip = hop['probes'][0]['ip']
            if ip is not None:
                private = ipaddress.ip_address(unicode(ip)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(hop['hop'])
                    private= ip
                else:
                    first_public_ip2 = ip
                    rtt_list=[]
                    for probe in  range (0, 2):
                        if hop['probes'][probe]['rtt'] is not None:
                            rtt_list.append(hop['probes'][probe]['rtt'])
                        else:
                            rtt_list.append(1000000)
                    rtt_min = min(rtt_list)
                    #print "first public ip:" + str(ip) + ", hop:" + str(hop['hop'])
                    return first_public_ip2
                    break
            else:
                num_none=num_none+1
                none_list.append(hop['hop'])
    if first_public_ip2==None:
        return 0

def first_private_ip_fun(target, file):
    num_private=0
    num_none=0
    count=0
    private_list=[]
    none_list=[]
    first_public_ip2 = None
    private_ip = None
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip_priv = hop['probes'][0]['ip']
            if ip_priv is not None:
                private = ipaddress.ip_address(unicode(ip_priv)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(ip_priv)
                    private_ip = ip_priv
                else:
                    first_public_ip2 = ip_priv
                    rtt_list=[]
                    for probe in  range (0, 2):
                        if hop['probes'][probe]['rtt'] is not None:
                            rtt_list.append(hop['probes'][probe]['rtt'])
                        else:
                            rtt_list.append(1000000)
                    rtt_min = min(rtt_list)
        #print "first public ip:" + str(ip) + ", hop:" + str(hop['hop'])
        else:
            num_none=num_none+1
            none_list.append(hop['hop'])
    if (len(private_list)>1):
        return private_list[1]
    else:
        return 0

def all_private_ip_fun(target, file):
    num_private=0
    num_none=0
    count=0
    private_list=[]
    none_list=[]
    first_public_ip2 = None
    private_ip = None
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip_priv = hop['probes'][0]['ip']
            if ip_priv is not None:
                private = ipaddress.ip_address(unicode(ip_priv)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(ip_priv)
                    private_ip = ip_priv
                else:
                    first_public_ip2 = ip_priv
                    rtt_list=[]
                    for probe in  range (0, 2):
                        if hop['probes'][probe]['rtt'] is not None:
                            rtt_list.append(hop['probes'][probe]['rtt'])
                        else:
                            rtt_list.append(1000000)
                    rtt_min = min(rtt_list)
        #print "first public ip:" + str(ip) + ", hop:" + str(hop['hop'])
        else:
            num_none=num_none+1
            none_list.append(hop['hop'])
    if (len(private_list)>1):
        return private_list
    else:
        return 0

def first_public_ip_rtt(target, file):
    num_private=0
    num_none=0
    private_list=[]
    none_list=[]
    first_public_ip2 = None
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            ip = hop['probes'][0]['ip']
            if ip is not None:
                private = ipaddress.ip_address(unicode(ip)).is_private
                if private:
                    num_private=num_private+1
                    private_list.append(hop['hop'])
                    private= ip
                else:
                    first_public_ip2 = ip
                    rtt_list=[]
                    for probe in  range (0, 2):
                        if hop['probes'][probe]['rtt'] is not None:
                            rtt_list.append(hop['probes'][probe]['rtt'])
                        else:
                            rtt_list.append(1000000)
                    rtt_min = min(rtt_list)
                #print "first public ip:" + str(ip) + ", hop:" + str(hop['hop'])
                    return rtt_min
                    break
            else:
                num_none=num_none+1
                none_list.append(hop['hop'])
    if first_public_ip2==None:
        return 0

def rtt(target, file):
    num_private=0
    num_none=0
    rtt_list=[]
    rtt_min = 0
    for hop in traceroute[target]['traceroute']['hops']:
        if hop['probes']:
            rtt_list=[]
            for probe in  range (0, 2):
                if hop['probes'][probe]['rtt'] is not None:
                    rtt_list.append(hop['probes'][probe]['rtt'])
                else:
                    rtt_list.append(1000000)
            rtt_min = min(rtt_list)
    return rtt_min

def roaming_country_fun (node_id):
        roaming_country=None
        if(node_id=="285" or node_id=="329"):
        	roaming_country = "Spain"
        if(node_id=="322" or node_id=="323" or node_id=="333" or node_id=="332"):
                roaming_country = "Italy"
        if(node_id=="328" or node_id=="298"):
                roaming_country = "Norway"
        if(node_id=="496" or node_id=="497"):
                roaming_country = "Sweden"
        if(node_id=="519" or node_id=="302"):
                roaming_country = "Germany"
        if(node_id=="549" or node_id=="518"):
                roaming_country = "UK"
        return roaming_country

targets=['141.40.254.120', '163.117.253.6', '139.133.232.22', '130.192.181.137', '193.10.227.25', '128.39.37.161']
dis_home={}
print "country" + ";" + "node_id" + ";" + "operator" + ";"+ "filepath" + ";" + "target" + ";" + "NWMCCMNC"+ ";"  + "IMSIMCCMNC" + ";" + "time" + ";" + "num_private_ip" + ";"+ "dis_target" + ";"+  "rtt_first_ip" + ";" + "rtt_target" + ";" + "num_public_ip_first_AS" + ";" +"first_private_ip"+ ";" + "private_ip_list" + ";" + "first_public_ip"+ ";" + "public_ip_list"

#find the difference between distance roaming and distance home
for subdir, dirs, files in os.walk(os.getcwd()):
    for file in files:
        filepath = subdir + os.sep + file
        if filepath.endswith(".json") and ("PINGTR" in filepath):
            with open(filepath) as f:
                traceroute = json.load(f)
                operator = traceroute['Operator']
                node_id = traceroute['NodeId']
                NWMCCMNC = traceroute['NWMCCMNC']
                IMSIMCCMNC = traceroute['IMSIMCCMNC']
                country = roaming_country_fun(node_id)
                time = traceroute['Timestamp']
            #find the first public IP
            for target in targets:
                #find the distance in hops between the hops in roaming and the hops at home
                dis_roaming = distance (target, filepath)
                private_ip = private_ip_fun (target, filepath)
                num_public_ip_first_AS = num_public_ip_first_AS_fun (target, filepath)
                first_public_ip = first_public_ip_fun(target, filepath)
                first_private_ip = first_private_ip_fun(target, filepath)
                private_ip_list =all_private_ip_fun(target, filepath)
                public_ip_list = all_public_ip_first_AS_fun(target, filepath)
                rtt_first_ip = first_public_ip_rtt(target, filepath)
                rtt_target = rtt(target, filepath)
                if (dis_roaming<30):
                    print country + "; " + node_id + "; "+ operator + ";"+ filepath + ";" + str(target) + ";" + str(NWMCCMNC)+ ";" + str(IMSIMCCMNC) + ";" + str (time) + ";" + str(private_ip) + ";"+ str(dis_roaming) + ";"+  str(rtt_first_ip) + ";" + str(rtt_target) + ";" + str(num_public_ip_first_AS)+ ";" + str(first_private_ip)+ ";" + str(private_ip_list) + ";" + str(first_public_ip)+ ";" + str(public_ip_list)


